/*******************************************************************************
 * Copyright (C) 2009-2011 FuseSource Corp.
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *******************************************************************************/
#include "hawtjni-example.h"
#include "hawtjni.h"
#include "hawtjni-example_structs.h"

typedef struct foo_FID_CACHE {
	int cached;
	jclass clazz;
	jfieldID a, b, c, c5, prev;
} foo_FID_CACHE;

foo_FID_CACHE fooFc;

void cachefooFields(JNIEnv *env, jobject lpObject)
{
	if (fooFc.cached) return;
	fooFc.clazz = (*env)->GetObjectClass(env, lpObject);
	fooFc.a = (*env)->GetFieldID(env, fooFc.clazz, "a", "I");
	fooFc.b = (*env)->GetFieldID(env, fooFc.clazz, "b", "J");
	fooFc.c = (*env)->GetFieldID(env, fooFc.clazz, "c", "[B");
	fooFc.c5 = (*env)->GetFieldID(env, fooFc.clazz, "c5", "B");
	fooFc.prev = (*env)->GetFieldID(env, fooFc.clazz, "prev", "J");
	fooFc.cached = 1;
}

struct foo *getfooFields(JNIEnv *env, jobject lpObject, struct foo *lpStruct)
{
	if (!fooFc.cached) cachefooFields(env, lpObject);
	lpStruct->a = (*env)->GetIntField(env, lpObject, fooFc.a);
	lpStruct->b = (size_t)(*env)->GetLongField(env, lpObject, fooFc.b);
	{
	jbyteArray lpObject1 = (jbyteArray)(*env)->GetObjectField(env, lpObject, fooFc.c);
	(*env)->GetByteArrayRegion(env, lpObject1, 0, sizeof(lpStruct->c), (jbyte *)lpStruct->c);
	}
	lpStruct->c[5] = (*env)->GetByteField(env, lpObject, fooFc.c5);
	lpStruct->prev = (void *)(intptr_t)(*env)->GetLongField(env, lpObject, fooFc.prev);
	return lpStruct;
}

void setfooFields(JNIEnv *env, jobject lpObject, struct foo *lpStruct)
{
	if (!fooFc.cached) cachefooFields(env, lpObject);
	(*env)->SetIntField(env, lpObject, fooFc.a, (jint)lpStruct->a);
	(*env)->SetLongField(env, lpObject, fooFc.b, (jlong)lpStruct->b);
	{
	jbyteArray lpObject1 = (jbyteArray)(*env)->GetObjectField(env, lpObject, fooFc.c);
	(*env)->SetByteArrayRegion(env, lpObject1, 0, sizeof(lpStruct->c), (jbyte *)lpStruct->c);
	}
	(*env)->SetByteField(env, lpObject, fooFc.c5, (jbyte)lpStruct->c[5]);
	(*env)->SetLongField(env, lpObject, fooFc.prev, (jlong)(intptr_t)lpStruct->prev);
}

typedef struct point_FID_CACHE {
	int cached;
	jclass clazz;
	jfieldID x, y;
} point_FID_CACHE;

point_FID_CACHE pointFc;

void cachepointFields(JNIEnv *env, jobject lpObject)
{
	if (pointFc.cached) return;
	pointFc.clazz = (*env)->GetObjectClass(env, lpObject);
	pointFc.x = (*env)->GetFieldID(env, pointFc.clazz, "x", "I");
	pointFc.y = (*env)->GetFieldID(env, pointFc.clazz, "y", "I");
	pointFc.cached = 1;
}

point *getpointFields(JNIEnv *env, jobject lpObject, point *lpStruct)
{
	if (!pointFc.cached) cachepointFields(env, lpObject);
	lpStruct->x = (*env)->GetIntField(env, lpObject, pointFc.x);
	lpStruct->y = (*env)->GetIntField(env, lpObject, pointFc.y);
	return lpStruct;
}

void setpointFields(JNIEnv *env, jobject lpObject, point *lpStruct)
{
	if (!pointFc.cached) cachepointFields(env, lpObject);
	(*env)->SetIntField(env, lpObject, pointFc.x, (jint)lpStruct->x);
	(*env)->SetIntField(env, lpObject, pointFc.y, (jint)lpStruct->y);
}

